const express = require('express')
const session = require('express-session')
const dotenv = require('dotenv');
const path = require('path');
const passport = require('passport');
const nodemailer = require('nodemailer');
const eta = require("eta");
const flash = require('connect-flash');
const bodyParser = require('body-parser');
require('dotenv').config({path: './config/config.env'});
const app = express();
const PORT = process.env.PORT || 3000;
app.use(express.static(path.join(__dirname, 'public')));
const routes = require('./routes/index');

app.set('view engine', 'eta');
app.engine("eta", eta.renderFile)
app.use(session({
    secret: 'thatsecretthinggoeshere',
    resave: false,
    saveUninitialized: true
}));
app.use(bodyParser.urlencoded({
    extended: true
}));
app.use(bodyParser.json());
app.use(flash());
 /* -------------- PASSPORT AUTHENTICATION ----------------
 */

app.use(passport.initialize());
app.use(passport.session());


app.use(function(req, res, next){
    res.locals.message = req.flash('message');
    next();
});

app.use('/priv', routes);
require('./config/passport')(passport);

app.get("/", (req, res) => {
    res.render("home", {
      title: "My New Site",
      message: "Welcome to My New Site!"
    });
  });
  
app.get("/aboutus", (req, res) => {
    res.render("aboutus", {
      title: "AboutUs"
    });
  });
  
app.get("/findus", (req, res) => {
    res.render("findus", {
      title: "FindUs"
    });
  });
  
app.get("/contactus", (req, res) => {
    res.render("contact", {
      title: "Contact Us"
    });
  });

app.post('/contact', (req, res) => {

  // Instantiate the SMTP server
  const smtpTrans = nodemailer.createTransport({
    sendmail: true,
    newline: 'unix',
    path: '/usr/sbin/sendmail'
    });

  // Specify what the email will look like
  const mailOpts = {
    from: process.env.EMAILUSER, // This is ignored
    to: process.env.EMAILUSER,
    subject: 'New message from contact form at myexample.com',
    text: `${req.body.name} (${req.body.email}) says: ${req.body.message}`
  }

  // Attempt to send the email
  smtpTrans.sendMail(mailOpts, (error, response) => {
	if (req.body.token === '41') {
    if (error) {
      res.render('contact', {
            message: 'Failure to Send Message',
            messageClass: 'alert-danger',
			title: 'Contact US'
        });
    } else {
      res.render('contact', {
            message: 'Successfully Sent Message',
            messageClass: 'alert-danger',
			title: 'Contact US'
        });
  
  };
      } else {
      res.render('contact', {
            message: 'Figure 41 not entered',
            messageClass: 'alert-danger',
			title: 'Contact US'  
     });
  };
 });
 
});
 
  
app.get('*', (req, res) => {
    res.render("none", {
      title: "404"
    });
  });

app.listen(PORT, () => {
    console.log(`Application server started on port: ${PORT}`)
});